package com.kingdee.eas.hr.project.handler;

import com.google.common.collect.Maps;
import com.google.common.collect.Sets;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.ctrl.kdf.table.IRow;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.rabbitmq.guava.Lists;
import com.kingdee.eas.basedata.person.PersonFactory;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.framework.ICoreBase;
import com.kingdee.eas.hr.project.*;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.base.syssetting.SHRCommonFacadeFactory;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.ml.SHRWebResource;
import com.kingdee.shr.base.syssetting.web.dynamic.model.ListUIViewInfo;
import com.kingdee.shr.base.syssetting.web.dynamic.model.TreeNavigationInfo;
import com.kingdee.shr.base.syssetting.web.dynamic.model.UIViewInfo;
import com.kingdee.shr.base.syssetting.web.handler.ListHandler;
import com.kingdee.shr.base.syssetting.web.plugin.PluginUtil;
import com.kingdee.util.StringUtils;
import org.springframework.ui.ModelMap;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.sql.SQLException;
import java.text.MessageFormat;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * @BelongsProject: dataImpExp820
 * @BelongsPackage: com.kingdee.eas.hr.project.handler
 * @Author: lhbj
 * @CreateTime: 2024-11-27  18:21
 * @Description: TODO
 * @Version: 1.0
 */
public class MemberManagementListHandler extends ProjectTreeListHandler {
    protected String pTypeManagerNumber = "ProjectManager";

    protected String pTypeNumber = "ProjectMember";

    @Override
    public String enableAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        String billId = this.getBillId(request);
        String[] ids = billId.split(",");
        Context ctx = SHRContext.getInstance().getContext();

        boolean isHandleEnable=false;
        try {
            IMemberManagement iManagement = MemberManagementFactory.getLocalInstance(ctx);
            IProjectRole iProjectRole = ProjectRoleFactory.getLocalInstance(ctx);
            IProjectType iPType = ProjectTypeFactory.getLocalInstance(ctx);
            for (String str : ids) {
                Set<String> idset = Sets.newHashSet();
                idset.addAll(Arrays.asList(ids));
                idset.remove(str);
                MemberManagementInfo management = iManagement.getMemberManagementInfo(new ObjectUuidPK(str));
                ProjectRoleInfo projectRole = management.getProjectRole();
                PersonInfo personInfo = management.getEmployee();
                ProjectManagementInfo projectManagement = management.getProjectManagement();
                ProjectTypeInfo pType = management.getPtype();
                pType = iPType.getProjectTypeInfo(new ObjectUuidPK(pType.getId()));
                projectRole =iProjectRole.getProjectRoleInfo(new ObjectUuidPK(projectRole.getId()));
                //жϵǰĿûѾ
                StringBuilder selPe = new StringBuilder();
                selPe.append(" select fid from CT_PRO_MEMBERMANAGEMENT ");
                selPe.append(" where CFPROJECTMANAGEMENID = ? ");
                selPe.append(" and CFEMPLOYEEID = ? ");
                selPe.append(" and CFSTATE = 1 ");
                IRowSet rs = DbUtil.executeQuery(ctx,selPe.toString(),new String[]{projectManagement.getId().toString(),personInfo.getId().toString()});
                if(rs.next()){
                    isHandleEnable=false;
                    throw new ShrWebBizException("ѾĿ" + pType.getName() + "ĳԱ,ȽԱú,顣");
                }

                FilterInfo filterInfo = new FilterInfo();
                filterInfo.getFilterItems().add(new FilterItemInfo("projectManagement.id", projectManagement.getId().toString(), CompareType.EQUALS));
                //ΪɫΪĿʱжϽɫ
                if(!(pTypeManagerNumber.equals(pType.getNumber()))) {
                    filterInfo.getFilterItems().add(new FilterItemInfo("projectRole.id", projectRole.getId().toString(), CompareType.EQUALS));
                }
                filterInfo.getFilterItems().add(new FilterItemInfo("state", "1", CompareType.EQUALS));
                filterInfo.getFilterItems().add(new FilterItemInfo("ptype.id", pType.getId().toString(), CompareType.EQUALS));
                filterInfo.getFilterItems().add(new FilterItemInfo("ptype.number", pTypeNumber, CompareType.NOTEQUALS));

                FilterInfo filterInfo4Or = new FilterInfo();
                filterInfo4Or.getFilterItems().add(new FilterItemInfo("id",idset,CompareType.INCLUDE));
                filterInfo4Or.getFilterItems().add(new FilterItemInfo("projectManagement.id", projectManagement.getId().toString(), CompareType.EQUALS));
                //ΪɫΪĿʱжϽɫ
                if(!(pTypeManagerNumber.equals(pType.getNumber()))) {
                    filterInfo4Or.getFilterItems().add(new FilterItemInfo("projectRole.id", projectRole.getId().toString(), CompareType.EQUALS));
                }
                //filterInfo4Or.getFilterItems().add(new FilterItemInfo("state", "1", CompareType.EQUALS));
                filterInfo4Or.getFilterItems().add(new FilterItemInfo("ptype.id", pType.getId().toString(), CompareType.EQUALS));
                filterInfo4Or.getFilterItems().add(new FilterItemInfo("ptype.number", pTypeNumber, CompareType.NOTEQUALS));

                filterInfo.mergeFilter(filterInfo4Or, "or");
                System.out.println(filterInfo.toSql());
                if (iManagement.exists(filterInfo)) {
                    isHandleEnable=false;
                    if((pTypeManagerNumber.equals(pType.getNumber()))) {
                        throw new ShrWebBizException("ѾĿ" + pType.getName() + "ĳԱ,ȽԱúáѡ˶λĿ顣");
                    }else {
                        throw new ShrWebBizException("ѾĿ" + pType.getName() + ",Ŀɫ" + projectRole.getName() + "ĳԱ,ȽԱúá");
                    }

                }else{
                    isHandleEnable=true;
                }
            }
        } catch (BOSException e) {
            throw new RuntimeException(e);
        } catch (EASBizException e) {
            throw new RuntimeException(e);
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        }
        if(isHandleEnable){
            this.handleEnableEx(request, "enable");
        }
        return null;
    }
    public String disableAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        return this.handleEnableEx(request, "disable");
    }
    protected String handleEnableEx(HttpServletRequest request, String methodName) throws SHRWebException {
        String billId = this.getBillId(request);
        String[] ids = billId.split(",");
        ICoreBase iCoreBase = this.getBizInterface(request);
        Context ctx = SHRContext.getInstance().getContext();
        String[] var7;
        int var8;
        int var9;
        String id;
        if (!"disable".equals(methodName) && !"enable".equals(methodName)) {
            throw new ShrWebBizException(MessageFormat.format(SHRWebResource.getString("com.kingdee.shr.base.syssetting.SHRSyssettingResource", "method_notexist"), iCoreBase.getName(), methodName));
        } else {
            var7 = ids;
            var8 = ids.length;

            for(var9 = 0; var9 < var8; ++var9) {
                id = var7[var9];
                this.doEnableBySqlEx(ctx ,id, methodName);
            }

            return null;
        }
    }
    protected void doEnableBySqlEx(Context ctx,String billId, String math) throws SHRWebException {
        try {

            IMemberManagement iManagement = MemberManagementFactory.getLocalInstance(ctx);
            MemberManagementInfo management = iManagement.getMemberManagementInfo(new ObjectUuidPK(billId));
            ProjectManagementInfo projectManagement= ProjectManagementFactory.getLocalInstance(ctx).
                    getProjectManagementInfo(new ObjectUuidPK(management.getProjectManagement().getId()));
            PersonInfo personInfo= PersonFactory.getLocalInstance(ctx).
                    getPersonInfo(new ObjectUuidPK(management.getEmployee().getId()));
            if ("disable".equals(math)) {
                String number= projectManagement.getNumber()+ "-" +personInfo.getNumber()+"-2";
                management.setNumber(number);
            }else if("enable".equals(math)){
                String number= projectManagement.getNumber()+ "-" +personInfo.getNumber()+"-1";
                management.setNumber(number);
            }
            System.out.println("doEnableBySqlEx:"+management.getNumber());
            DbUtil.execute(ctx,"update CT_PRO_MemberManagement set fnumber='"+management.getNumber()+"' where fid='"+billId+"'");
            SHRCommonFacadeFactory.getRemoteInstance().updateEnable(billId, math);
        } catch (EASBizException var4) {
            throw new ShrWebBizException(var4.getMessage(), var4);
        } catch (BOSException var5) {
            throw new SHRWebException(var5.getMessage(), var5);
        }
    }
    protected String getBillId(HttpServletRequest request) throws SHRWebException {
        String billId = (String)request.getAttribute("billId");
        if (StringUtils.isEmpty(billId)) {
            billId = request.getParameter("billId");
        }

        if (StringUtils.isEmpty(billId)) {
            billId = request.getParameter("billID");
        }

        if (StringUtils.isEmpty(billId)) {
            throw new ShrWebBizException(MessageFormat.format(SHRWebResource.getString("com.kingdee.shr.base.syssetting.SHRSyssettingResource", "is_empty"), "billId"));
        } else {
            return billId;
        }
    }

//    @Override
//    protected FilterInfo getDefaultFilter(HttpServletRequest request, HttpServletResponse response) throws SHRWebException {
//        String userAdminOrgRangeSql = this.assembleTreeDataUserAdminOrgRangeSQL(request);
//        FilterInfo ifo = new FilterInfo();
//        ifo.getFilterItems().add(new FilterItemInfo("projectManagement.adminOrg.id in("+userAdminOrgRangeSql+")"));
//        ifo.getFilterItems().add(new FilterItemInfo("projectManagement.projectState in('1','2')"));
//        return ifo;
//    }
}
